
-- You may customize the colors of the bars below.  Don't edit anything below the line.

-- Colors are on a scale of 0.0 - 1.0 in this game.  To convert RGB (Red Blue Green) decimal to it, just divide it by 255.

-- ex. 255, 150, 50 = 1.0, 0.6, 0.2

-- Channeling Color:

local chanR = 1.0;
local chanG = 0.7;
local chanB = 0.0;

-- Casting Color:

local castR = 1.0;
local castG = 0.7;
local castB = 0.0;

-- Normal Exp Color:

local normR = 1.0;
local normG = 1.0;
local normB = 0.2;

-- Rested Actual Exp Color:

local actR = 0.1;
local actG = 0.5;
local actB = 1.0;

-- Rested Future Exp Color:

local futR = 0.4;
local futG = 0.8;
local futB = 1.0;

-- Color of time left when casting

local timeR = 1.0;
local timeG = 0.82;
local timeB = 0.0;

-- Display time remaining on cast? (0 for no and 1 for yes)

local displayTime = 1;

-- Show Spell Name? (0 for no and 1 for yes)

local showSpellName = 1;

-- The spell font size

local spellFont = 8;

-------------------------------------------------------------------

CEPlayerBarTemp = 0;
CEPlayerBarPercentEnabled = nil;
CEPlayerBarPercentShow = "&remainingxppercent%";
CEPlayerBarHover = "&percentxp% XP";
CEPlayerBarHoverRest = "&percentxp% XP";
CEPlayerBarHoverMain = "&playername";

-- variables to store the original player name color

local origPlayerR = nil;
local origPlayerG = nil;
local origPlayerB = nil;

-- casting related variables

local spell, casting, channeling, startTime, endTime, font, oldFontSize, otherStuff = nil;

-- so we can hide the vehicle casting bar, but not a pet one

local PlayerInVehicle;
local PetFrameHijacked = 0;

function CEPlayerBar_CheckVehicleStatus()
	PlayerInVehicle = UnitInVehicle("player");
	if (PetFrameHijacked == 0 and PlayerInVehicle == 1) then
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_START");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_STOP");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_DELAYED");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
		PetCastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
		PetFrameHijacked = 1;
	elseif (PetFrameHijacked == 1 and PlayerInVehicle == 0) then
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_START");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_STOP");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_FAILED");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_DELAYED");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
		PetCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
		PetFrameHijacked = 0;
	end
	
end

function CEPlayerBar_OnLoad ()

	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("UPDATE_EXHAUSTION");
	this:RegisterEvent("VARIABLES_LOADED");

	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_START");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_STOP");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_DELAYED");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
	CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");

	this:RegisterEvent("UNIT_SPELLCAST_START");
	this:RegisterEvent("UNIT_SPELLCAST_STOP");
	this:RegisterEvent("UNIT_SPELLCAST_FAILED");
	this:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
	this:RegisterEvent("UNIT_SPELLCAST_DELAYED");
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
	casting = nil;

	SlashCmdList["CEP"] = cepconfig;
	SLASH_CEP1 = "/cep";

	origPlayerR,origPlayerG,origPlayerB = PlayerName:GetTextColor();
	font, oldFontSize, otherStuff = PlayerName:GetFont();

end

function cepconfig (msg)
	local cepKeyword, cepParams;
	if (strfind(msg," ") == nil) then
		cepKeyword = msg;
		cepParams = nil;
	else
		cepKeyword = strsub(msg,0,strfind(msg," ")-1);
		cepParams = strsub(msg,strfind(msg," ")+1,strlen(msg));
		local cepParamsTemp = strsub(cepParams,0,1);
		if ((cepParams == "") or (cepParamsTemp == " ")) then
			cepParams = nil;
		end
	end
	if (cepKeyword == "percent") then
		if (CEPlayerBarPercentEnabled == 1) then
			CEPlayerBarPercentEnabled = nil;
			DEFAULT_CHAT_FRAME:AddMessage("cep: Side percent view disabled.");
			CEPlayerBarPercent:Hide();
		else
			CEPlayerBarPercentEnabled = 1;
			DEFAULT_CHAT_FRAME:AddMessage("cep: Side percent view enabled.");
			CEPlayerBarPercent:Show();
			local ExpPercentage = UnitXP("player") / UnitXPMax("player") * 100;
			CEPlayerBarPercent:SetText(floor(ExpPercentage).."%");
		end
	elseif ((cepKeyword == "setnorm") and (cepParams ~= nil)) then
		CEPlayerBarHover = cepParams;
		DEFAULT_CHAT_FRAME:AddMessage("cep: Normal hover text set to ".."\""..CEPlayerBarHover.."\"");
		CEPlayerBar_UpdateIt();
	elseif ((cepKeyword == "setrest") and (cepParams ~= nil)) then
		CEPlayerBarHoverRest = cepParams;
		DEFAULT_CHAT_FRAME:AddMessage("cep: Rest hover text set to ".."\""..CEPlayerBarHoverRest.."\"");
		CEPlayerBar_UpdateIt();
	elseif ((cepKeyword == "setmain") and (cepParams ~= nil)) then
		CEPlayerBarHoverMain = cepParams;
		DEFAULT_CHAT_FRAME:AddMessage("cep: Main text set to ".."\""..CEPlayerBarHoverMain.."\"");
		CEPlayerBar_UpdateIt();
	elseif ((cepKeyword == "setside") and (cepParams ~= nil)) then
		CEPlayerBarPercentShow = cepParams;
		DEFAULT_CHAT_FRAME:AddMessage("cep: Side text set to ".."\""..CEPlayerBarPercentShow.."\"");
		CEPlayerBar_UpdateIt();
	elseif (cepKeyword == "reset") then
		CEPlayerBarPercentShow = "&remainingxppercent%";
		DEFAULT_CHAT_FRAME:AddMessage("cep: Side text set to ".."\""..CEPlayerBarPercentShow.."\"");
		CEPlayerBarHover = "&percentxp% XP";
		DEFAULT_CHAT_FRAME:AddMessage("cep: Normal hover text set to ".."\""..CEPlayerBarHover.."\"");
		CEPlayerBarHoverRest = "&percentxp% XP";
		DEFAULT_CHAT_FRAME:AddMessage("cep: Rest hover text set to ".."\""..CEPlayerBarHoverRest.."\"");
		CEPlayerBarHoverMain= "&playername";
		DEFAULT_CHAT_FRAME:AddMessage("cep: Main text set to ".."\""..CEPlayerBarHoverMain.."\"");
		CEPlayerBar_UpdateIt();
	elseif (cepKeyword == "show") then
		DEFAULT_CHAT_FRAME:AddMessage("cep: Side text set to ".."\""..CEPlayerBarPercentShow.."\"");
		DEFAULT_CHAT_FRAME:AddMessage("cep: Normal hover text set to ".."\""..CEPlayerBarHover.."\"");
		DEFAULT_CHAT_FRAME:AddMessage("cep: Rest hover text set to ".."\""..CEPlayerBarHoverRest.."\"");
		DEFAULT_CHAT_FRAME:AddMessage("cep: Main text set to ".."\""..CEPlayerBarHoverMain.."\"");
		if (CEPlayerBarPercentEnabled == 1) then
			DEFAULT_CHAT_FRAME:AddMessage("cep: Percent side view is on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("cep: Percent side view is off");
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("CEPlayerBar");
		DEFAULT_CHAT_FRAME:AddMessage("  USAGE: /cep <keyword> [args]");
		DEFAULT_CHAT_FRAME:AddMessage("    percent - toggles side percent view");
		DEFAULT_CHAT_FRAME:AddMessage("    show - displays all settings");
		DEFAULT_CHAT_FRAME:AddMessage("    reset - resets everything to default");
		DEFAULT_CHAT_FRAME:AddMessage("    setside <text> - changes side text on player frame");
		DEFAULT_CHAT_FRAME:AddMessage("    setnorm <text> - changes normal hover text on player frame");
		DEFAULT_CHAT_FRAME:AddMessage("    setrest <text> - changes rested hover text on player frame");
		DEFAULT_CHAT_FRAME:AddMessage("    setmain <text> - changes main text on player frame");
		DEFAULT_CHAT_FRAME:AddMessage("  VARIABLES (to be used with setside, setnorm, setrest, and setmain):");
		DEFAULT_CHAT_FRAME:AddMessage("    &playername - returns player's name");
		DEFAULT_CHAT_FRAME:AddMessage("    &percentxp - returns xp in percent");
		DEFAULT_CHAT_FRAME:AddMessage("    &remainingxppercent - returns xp left to next level in percent");
		DEFAULT_CHAT_FRAME:AddMessage("    &currentxp - returns current xp");
		DEFAULT_CHAT_FRAME:AddMessage("    &maxxp - returns maximum xp possible for the level");
		DEFAULT_CHAT_FRAME:AddMessage("    &restxp - returns rest xp");
		DEFAULT_CHAT_FRAME:AddMessage("    &remainingxp - returns xp left to next level");
		DEFAULT_CHAT_FRAME:AddMessage("  EXAMPLES:");
		DEFAULT_CHAT_FRAME:AddMessage("    /cep percent");
		DEFAULT_CHAT_FRAME:AddMessage("    /cep setside &percentxp%");
		DEFAULT_CHAT_FRAME:AddMessage("    /cep setmain &playername (&percentxp%)");
		DEFAULT_CHAT_FRAME:AddMessage("    /cep setrest &restxp xp");
		DEFAULT_CHAT_FRAME:AddMessage("    /cep setnorm &currentxp / &maxxp");
	end
end

function CEPlayerBar_OnEvent (event)

	-- Check vehicle status
	local isEligible = 0;
	local type = arg1;
	if ( (PlayerInVehicle == 1 and arg1 == "vehicle") or arg1 == "player") then
		isEligible = 1;
	end

	if ( event == "UNIT_SPELLCAST_START" and isEligible == 1 ) then

		CEPlayerBar:SetStatusBarColor(castR, castG, castB);
		PlayerName:SetFont(font,spellFont,otherStuff);
		spell, _, _, _, startTime, endTime = UnitCastingInfo(type);
		startTime = startTime / 1000;
		endTime = endTime / 1000;
		CEPlayerBar:SetMinMaxValues(startTime, endTime);
		CEPlayerBar:SetValue(startTime);
		if (displayTime == 1 and showSpellName == 1) then
			if (math.floor((endTime - startTime) / 1000) == (endTime - startTime) / 1000) then

				PlayerName:SetText( spell .. " " .. ((endTime - startTime) / 1000) .. ".0");

			else

				PlayerName:SetText( spell .. " " .. (endTime - startTime) / 1000);

			end
			PlayerName:SetTextColor(timeR,timeG,timeB);
		elseif (displayTime == 1 and showSpellName == 0) then
			if (math.floor((endTime - startTime) / 1000) == (endTime - startTime) / 1000) then

				PlayerName:SetText(((endTime - startTime) / 1000) .. ".0");

			else

				PlayerName:SetText((endTime - startTime) / 1000);

			end
			PlayerName:SetTextColor(timeR,timeG,timeB);
		elseif (displayTime == 0 and showSpellName == 1) then
			PlayerName:SetText( spell );
			PlayerName:SetTextColor(timeR,timeG,timeB);
		end
		casting = 1;
		CEPlayerBarExhaust:SetStatusBarColor(0.4, 0.8, 0.1, 0.0);

	elseif ( event == "UNIT_SPELLCAST_STOP" and isEligible == 1 ) then
		if (casting == 1) then
			casting = nil;
			PlayerName:SetFont(font,oldFontSize,otherStuff);
			CEPlayerBar_ShowXP();
			CEPlayerBar_UpdateIt();
			return;
		end

	elseif (event == "UNIT_SPELLCAST_CHANNEL_STOP" and isEligible == 1 ) then
		if (channeling == 1) then
			channeling = nil;
			PlayerName:SetFont(font,oldFontSize,otherStuff);
			CEPlayerBar_ShowXP();
			CEPlayerBar_UpdateIt();
			return;
		end

	elseif ( (event == "UNIT_SPELLCAST_FAILED" or event == "SPELLCAST_INTERRUPTED") and isEligible == 1 ) then
		casting = nil;
		channeling = nil;
		CEPlayerBar_ShowXP();
		CEPlayerBar_UpdateIt();
		return;

	elseif ( event == "UNIT_SPELLCAST_DELAYED"  and isEligible == 1 ) then
		local _, _, _, _, _, newEndTime = UnitCastingInfo(type);
		newEndTime = newEndTime / 1000;
		endTime = newEndTime;
		CEPlayerBar:SetMinMaxValues(startTime, endTime);
		if (displayTime == 1) then
			if (math.floor(math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) == math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) then
				PlayerName:SetText((math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) .. ".0");
			else
				PlayerName:SetText(math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10);
			end
		end

	elseif ( event == "UNIT_SPELLCAST_CHANNEL_START" and isEligible == 1 ) then
		CEPlayerBar:SetStatusBarColor(chanR, chanG, chanB);
		PlayerName:SetFont(font,spellFont,otherStuff);
		spell, _, _, _, startTime, endTime = UnitChannelInfo(type);
		startTime = startTime / 1000;
		endTime = endTime / 1000;
		CEPlayerBar:SetMinMaxValues(startTime, endTime);
		CEPlayerBar:SetValue(endTime);
		if (displayTime == 1 and showSpellName == 1) then
			if (math.floor((endTime - startTime) / 1000) == (endTime - startTime) / 1000) then

				PlayerName:SetText( spell .. " " .. ((endTime - startTime) / 1000) .. ".0");

			else

				PlayerName:SetText( spell .. " " .. (endTime - startTime) / 1000);

			end
			PlayerName:SetTextColor(timeR,timeG,timeB);
		elseif (displayTime == 1 and showSpellName == 0) then
			if (math.floor((endTime - startTime) / 1000) == (endTime - startTime) / 1000) then

				PlayerName:SetText(((endTime - startTime) / 1000) .. ".0");

			else

				PlayerName:SetText((endTime - startTime) / 1000);

			end
			PlayerName:SetTextColor(timeR,timeG,timeB);
		elseif (displayTime == 0 and showSpellName == 1) then
			PlayerName:SetText( spell );
			PlayerName:SetTextColor(timeR,timeG,timeB);
		end
		casting = nil;
		channeling = 1;
		CEPlayerBarExhaust:SetStatusBarColor(0.4, 0.8, 0.1,0.0);

	elseif ( event == "UNIT_SPELLCAST_CHANNEL_UPDATE" and isEligible == 1 ) then
		local _, _, _, _, _, newEndTime = UnitChannelInfo(type);
		if (newEndTime ~= nil) then
			newEndTime = newEndTime / 1000;
			if ( GetTime() >= newEndTime ) then
				channeling = nil;
				CEPlayerBar_ShowXP();
				CEPlayerBar_UpdateIt();
				return;
			elseif ( channeling == 1 ) then
				local durationShift = endTime - newEndTime;
				endTime = newEndTime;
				CEPlayerBar:SetValue( CEPlayerBar:GetValue() - durationShift );
				if (displayTime == 1) then
					if (math.floor(math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) == math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) then
						PlayerName:SetText( spell .. " " .. (math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10) .. ".0");
					else
						PlayerName:SetText( spell .. " " .. math.floor((CEPlayerBar:GetValue() * 10) - (startTime * 10))/10);
					end
				end
			end
		end

	elseif ((event == "PLAYER_XP_UPDATE" or event == "PLAYER_LEVEL_UP" or event == "UPDATE_EXHAUSTION" or event == "PLAYER_ENTERING_WORLD") and casting ~= 1) then
		CEPlayerBar_ShowXP();
		CEPlayerBar_UpdateIt();
	end
end

function CEPlayerBar_OnClick(button)
	if ( SpellIsTargeting() and button == "RightButton" ) then
		SpellStopTargeting();
		return;
	end
	if ( button == "LeftButton" ) then
		if ( SpellIsTargeting() ) then
			-- SpellTargetUnit("player");
		elseif ( CursorHasItem() ) then
			AutoEquipCursorItem();
		else
			-- TargetUnit("player");
		end
	else
		ToggleDropDownMenu(1, nil, PlayerFrameDropDown, "PlayerFrame", 106, 27);
		return;
	end
end

function CEPlayerBar_UpdateIt()
	if (casting ~= 1) then
		if (CEPlayerBarTemp == 1) then
			if (GetRestState() == 1) then
				PlayerName:SetText(cepReplaceAll(CEPlayerBarHoverRest));
			elseif (GetRestState() == 2) then
				PlayerName:SetText(cepReplaceAll(CEPlayerBarHover));
			end
		else
			if (UnitInVehicle("player") == 1) then
				PlayerName:SetText(UnitName("vehicle"));
			else
				PlayerName:SetText(cepReplaceAll(CEPlayerBarHoverMain));
			end
		end
		if (CEPlayerBarPercentEnabled == 1) then
			CEPlayerBarPercent:Show();
			CEPlayerBarPercent:SetText(cepReplaceAll(CEPlayerBarPercentShow));
		else
			CEPlayerBarPercent:Hide();
		end
		if (displayTime == 1) then
			PlayerName:SetTextColor(origPlayerR,origPlayerG,origPlayerB);
		end
	end
end

function CEPlayerBar_ShowXP()

	CEPlayerBar:SetMinMaxValues(min(0, UnitXP("player")), UnitXPMax("player"));
	CEPlayerBar:SetValue(UnitXP("player"));
	CEPlayerBarExhaust:SetMinMaxValues(min(0, UnitXP("player")), UnitXPMax("player"));
	local ExpBarexhaustionTickSet;
	if (GetXPExhaustion() ~= nil) then
		ExpBarexhaustionTickSet = max(((UnitXP("player") + GetXPExhaustion()) / UnitXPMax("player")) * CEPlayerBar:GetWidth(), 0);
	else
		ExpBarexhaustionTickSet = max(UnitXP("player") / UnitXPMax("player") * CEPlayerBar:GetWidth(), 0);
	end
	if (ExpBarexhaustionTickSet > CEPlayerBar:GetWidth()) then
		CEPlayerBarExhaust:SetValue(UnitXPMax("player"));
	else
		CEPlayerBarExhaust:SetValue(ExpBarexhaustionTickSet / CEPlayerBar:GetWidth() * UnitXPMax("player"));
	end
	if (GetRestState() ~= nil) then
		if (GetRestState() == 1) then
			CEPlayerBar:SetStatusBarColor(actR, actG, actB, 1.0);
			CEPlayerBarExhaust:SetStatusBarColor(futR,futG,futB,1.0); 
		elseif (GetRestState() == 2) then
			CEPlayerBar:SetStatusBarColor(normR, normG, normB, 1.0);
		end
	end

end

function CEPlayerBar_UpdateTimers()

	if (casting or channeling) then

		local time = GetTime();
		if ( time  > endTime ) then
			time  = endTime;
		end

		if ( casting ) then
			CEPlayerBar:SetValue(time);
		elseif ( channeling ) then
			local barValue = startTime + (endTime - time);
			CEPlayerBar:SetValue(barValue);
		end

		if (displayTime == 1 and showSpellName == 1) then
			if (math.floor(math.floor((endTime * 10) - (time * 10))/10) == math.floor((endTime * 10) - (time * 10))/10) then
				PlayerName:SetText( spell .. " " .. (math.floor((endTime * 10) - (time * 10))/10)..".0");
			else
				PlayerName:SetText( spell .. " " .. math.floor((endTime * 10) - (time * 10))/10);
			end
		elseif (displayTime == 1 and showSpellName == 0) then
			if (math.floor(math.floor((endTime * 10) - (time * 10))/10) == math.floor((endTime * 10) - (time * 10))/10) then
				PlayerName:SetText((math.floor((endTime * 10) - (time * 10))/10)..".0");
			else
				PlayerName:SetText(math.floor((endTime * 10) - (time * 10))/10);
			end
		elseif (displayTime == 0 and showSpellName == 1) then
			PlayerName:SetText( spell );
		end

	end

end

function cepReplaceAll (str)
	local cepProcessed = str;
	cepProcessed = gsub(cepProcessed,"&playername",UnitName("player"));
	cepProcessed = gsub(cepProcessed,"&percentxp",floor(UnitXP("player")/UnitXPMax("player")*100));
	cepProcessed = gsub(cepProcessed,"&remainingxppercent",floor((UnitXPMax("player") - UnitXP("player"))/UnitXPMax("player")*100));
	cepProcessed = gsub(cepProcessed,"&currentxp",UnitXP("player"));
	cepProcessed = gsub(cepProcessed,"&maxxp",UnitXPMax("player"));
	cepProcessed = gsub(cepProcessed,"&remainingxp",UnitXPMax("player")-UnitXP("player"));
	if (GetXPExhaustion() ~= nil) then
		cepProcessedTemp = GetXPExhaustion()/2;
	else
		cepProcessedTemp = "0"; 
	end
	cepProcessed = gsub(cepProcessed,"&restxp",cepProcessedTemp);
	return cepProcessed;
end